<?php 

namespace PrestaShop\Module\PolarisPrestaConnector\Controller;

use PrestaShopBundle\Controller\Admin\FrameworkBundleAdminController;
use PrestaShop\Module\PolarisPrestaConnector\Forms\GrilleType;
use Symfony\Component\HttpFoundation\Request;
use PrestaShopLogger;


class PolarisPrestaConnectorConfigurationAdminController extends FrameworkBundleAdminController
{   


    public function grilleDeTaille(Request $request){
     

        $form = $this->createForm(GrilleType::class);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            //$data = $form->getData();


        }
       
     
        return $form;

    }

    

    public function informationAction(Request $request){

        $form = $this->createForm(\PrestaShop\Module\PolarisPrestaConnector\Forms\LcvLoginType::class);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $data = $form->getData();
            $username = $data['username'];
            $password = $data['password'];
            $url = $data['url'];


            // Connexion à l'API avec ces informations
            $this->connectToApi($username, $password,$url);

        }

        return $this->render('@Modules/prestaconnector/views/templates/admin/information.html.twig', [
            'form' => $form->createView(),
        ]);
  

    }

    public function optionAction(){
  
        return $this->render('@Modules/prestaconnector/views/templates/admin/option.html.twig', [
       
        ]);
    }

    public function commandeAction(){
  
        return $this->render('@Modules/prestaconnector/views/templates/admin/commande.html.twig', [
       
        ]);
    }
    public function catalogueAction(Request $request){

        $form = $this->grilleDeTaille($request);
  
        return $this->render('@Modules/prestaconnector/views/templates/admin/catalogue.html.twig', [
       'form' => $form->createView()
        ]);
    }

    private function connectToApi($username, $password , $url)
{
     // Gestion des erreurs dans la réponse de l'API avec un try-catch
    try {
        // URL de l'API avec les paramètres dans l'URL
        $apiUrl = sprintf('%s/LectureDesTables//%s/%s',
            urlencode($url),
            urlencode($username),   // sUser
            urlencode($password)    // sMdp
        );

        // Initialisation de la session cURL
        $ch = curl_init();

        // Configuration des options cURL pour une requête GET
        curl_setopt($ch, CURLOPT_URL, $apiUrl);
        curl_setopt($ch, CURLOPT_HTTPGET, true); // Utiliser la méthode GET
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true); // Pour retourner la réponse comme une chaîne
    
          
        // Exécution de la requête cURL
        $response = curl_exec($ch);
        
        // Fermer cURL
        curl_close($ch);
    
        var_dump($response);die;
        // si $response renvoi une erreur Exeption afin de declancher le catch
        if($response == " Erreur... Utilisateur inconnu "){
            
            throw new \Exception('Erreur... Utilisateur inconnu');
        }

        // Retourner la réponse si tout est correct
        return $this->addFlash(
            'sucess', 
            $this->trans('sucess connected to WEBSERVICE', 'Modules.prestaconnector.Admin')
        );

    } catch (\Exception $e) {
        // Enregistrer l'erreur dans les logs de PrestaShop
        PrestaShopLogger::addLog(
            'Erreur lors de la réponse de l\'API : ' . $e->getMessage(), 
            3, // Niveau critique
            null, 
        
        );

        // Ajouter un message flash pour informer l'utilisateur
        $this->addFlash(
            'error', 
            $this->trans('Erreur lors de la réponse de l\'API : ' . $e->getMessage(), 'Modules.prestaconnector.Admin')
        );

        return null;
    }
   

}

   

}